#! /usr/bin/perl
# mlview.cgi : view archive
# Copyright(C) 2001 by Yuh.N
# $Id: mlview.cgi,v 1.1 2001/02/02 08:54:07 yuh Exp $
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
umask(0077);
use CGI;

require '/usr/local/ppml/mimer.pl';
require "mllib.pl";

if (-f "$ML_SETTING_ROOT/mlinfo.ph") {
    require "$ML_SETTING_ROOT/mlinfo.ph";
    $mlinfo_loaded = 1;
}

$q = new CGI;
print $q->header(-expires=>now, -title=>'MLjoin');
print $q->start_html(-bgcolor=>'#ffffff');
print '<h1>᡼륢ֱ</h1>',"\n";

sub rev {
    $b <=> $a;
}

$scr = $ENV{'SCRIPT_NAME'};

$multi_column = 4;

if ($q->param("mode") eq "detail") {
    $detailed = 1;
}
else {
    $detailed = 0;
}

if (defined($q->param('ML'))) {
    $ml = $q->param('ML');
    if (MLconfig_read($ml) eq undef) {
	print "᡼󥰥ꥹ $ml ¸ߤޤ<br>\n";
	last;
    }

    if (defined($q->param('SEQ'))) {

	$seq = $q->param('SEQ');

	%H = MLget_message($ml, $seq);
	print "<table>\n";
	foreach $key ("To", "From", "Subject", "Date", "Message-Id") {
	    $_ = $H{$key};
	    s/</&lt;/g;
	    s/>/&gt;/g;
	    printf "<tr><th>$key</th><td>%s</td></tr>\n", mimedecode($_, 'EUC');
	}
	print "</table>\n";
	print "<pre>\n";
	$MIME::kout = 'EUC';
	$_ = &MIME::kconv($H{'Body'});
	s/<//g;
	s/>//g;
	s/((http|ftp):\/\/[A-Za-z0-9\-_=\+\/\.\~\#\%]+)/<a href=$1>$1<\/a>/g;
	print $_;
	print "</pre>\n";
    }
    else {

	opendir(ARC, "$ML_SETTING_ROOT/$ml/archive");
	@files = grep ! /^\./, readdir(ARC);
	closedir(ARC);

	foreach $seq (sort rev @files) {
	    %H = MLget_message($ml, $seq);
	    printf "<a href=$scr?ML=$ml\&SEQ=$seq target=top>";
	    ($S,$M,$H,$d,$m,$y) = MLdatetime($H{'Date'});
	    $str = sprintf("%02d/%02d ", $m+1, $d);
	    $str .= mimedecode($H{'Subject'}, 'EUC');
	    $n = 60 - length($str);
	    if ($n > 0) {
		$MIME::kout = 'EUC';
		$str .= "||";
		$str .= substr(&MIME::kconv($H{'Body'}), 0, $n);
	    }
	    printf "%s</a><br>", $str;
	}
    }
    
}
else {

    @mllist = MLlist();

    if ($detailed) {
	print "<a href=$scr?mode=simple>[άɽ (simplified)]</a>\n";
    }
    else {
	print "<a href=$scr?mode=detail>[ܺɽ (detailed)]</a>\n";
    }

    $n = 0;
    print "<table>\n";
    foreach $ml (@mllist) {
	next if (-f "$ML_SETTING_ROOT/$ml/.do_not_browse");
	next if (! -d "$ML_SETTING_ROOT/$ml/archive");
	print "<tr>\n" if ((($n % $multi_column) == 0) || ($detailed));
	print "<td><a href=$scr?ML=$ml>$ml</a></td>\n";
	print("<td>$mlinfotbl{$ml}</td>\n") if ($detailed);
	print "</tr>\n" if ((($n % $multi_column) == ($multi_column - 1)) || ($detailed));
	$n++;
    }
    print "</table>\n";

}


print $q->end_html();
