#!/usr/bin/perl
#
# Pigeon Post Digital Signature Tool for MIME-multipart mail
#
$CHKSUMTYPE = 'SHA1';
$MIMEANALYZE = 1;

&ParseInput(*e);
exit;

sub ParseInput{
    $0 = "ParseInput";
    local(*e) = @_;
    local(@header);
    local($mpp,$mpi,$h,$c,$hc,$s);
    $/ = "\n\n";
    $e{'Header'} = <STDIN>;
    $/ = "\n";
    $e{'size:header'} = length($e{'Header'});
    @header = split(/\n/,$e{'Header'});
    foreach (@header){
	if (/^([^\s\:]+)\:\s*(.*)/){
	    $h = $1;
	    $c = $2;
	    # field-name covert to unified form
	    $horg = $h;
	    $h =~ tr/A-Z/a-z/;
	    # message-id -> Message-id
	    if ( $h =~ /^(.)(.*)/ ){
                $hc = $1;
                $hc =~ tr/a-z/A-Z/;
                $h = $hc.$2;
	    }
	    # Message-id -> Message-Id
	    while ( $h =~ /^(.+)(\-[a-z])(.+)/ ){
                $hc = $2;
                $hc =~ tr/a-z/A-Z/;
                $h = $1.$hc.$3;
	    }
	    $e{"OH:$h"} = $horg;
	    if ((length($e{"H:$h"}) > 0)&&(length($c) > 0)){
		$e{"H:$h"} .= "$_\n";
	    }elsif((length($h) > 0) && (length($c) > 0)){ 
		$e{"H:$h"} .= "$c\n";
	    }
	}elsif(/^(\s+.*)/){
	    if ($h ne ""){
		$e{"H:$h"} .= "$_\n";
	    }else{
		$e{'bogus'} .= "$_\n";
	    }
	}else{
	    $e{'bogus'} .= "$_\n";
	}
    }
    while(<STDIN>){
	$e{'Body'} .= $_;
	$e{'line:body'}++;
	$e{'size:body'} += length($_);
    }
    if ($CHKSUMTYPE eq 'SHA1') {
	use Digest::SHA1 qw(sha1_base64);
	$e{'checksum:body'} = sha1_base64($e{'Body'});
    }elsif($CHKSUMTYPE eq 'MD5'){
	use Digest::MD5  qw(md5_base64);
	$e{'checksum:body'} = md5_base64($e{'Body'});
    }else{
	$e{'checksum:body'} = sprintf("%011d-%011d",$e{'size:body'},unpack("%31C*",$e{'Body'}));
    }
    $e{'size'} = $e{'size:header'} + $e{'size:body'};
    print "subject       = $e{'H:Subject'}";
    print "checksum:body = $e{'checksum:body'}\n";
    # multipart analyze
    if ((defined($MAXPARTSIZE)||$MIMEANALYZE) &&
	($e{'H:Content-Type'} =~ /multipart\/mixed\;/i) &&
	($e{'H:Content-Type'} =~ /boundary\=[\"]*([^\"\;]+)[\"]*/i)){ #"
	$e{'mp:boundary'} = $1;
	$e{'size:mp:boundary'} = length($e{'mp:boundary'});
	# partscan
	$mc = 0; $mcs = 'mp:00';
	foreach $line (split(/\n/,$e{'Body'})){
	    if ($line eq "--$e{'mp:boundary'}--"){last;};
	    if ($line eq "--$e{'mp:boundary'}"){
		$mc++;
		$mcs = sprintf("mp:%d",$mc);
		next;
	    }
	    $e{$mcs} .= "$line\n";
	}
	$e{'mp'} = $mc;
	delete $e{'mp:00'};
	for ($i = 1; $i <= $mc ; $i++){
	    $mcs = sprintf("mp:%d",$i);
	    ### MIME analyze
	    $e{"size:$mcs"} = length($e{$mcs});
	    $e{"mhead:$mcs"} = substr($e{$mcs},0,index($e{$mcs},"\n\n")+1);
	    $e{"mbody:$mcs"} = substr( $e{$mcs},index($e{$mcs},"\n\n")+2, index($e{$mcs},"--$e{'mp:boundary'}") );
	    if ($CHKSUMTYPE eq 'SHA1') {
		use Digest::SHA1 qw(sha1_base64);
		$e{"checksum:$mcs"} = sha1_base64($e{"mbody:$mcs"});
	    }elsif($CHKSUMTYPE eq 'MD5'){
		use Digest::MD5  qw(md5_base64);
		$e{"checksum:$mcs"} = md5_base64($e{"mbody:$mcs"});
	    }else{
		$e{"checksum:$mcs"} = sprintf("%011d-%011d",$e{"size:$mcs"},unpack("%31C*",$e{"mbody:$mcs"}));
	    }
	    $s = "\'".$e{"checksum:$mcs"}."\':";
	    if ( $e{"mhead:$mcs"} =~ /Content\-Type\:\s*([^\;]+)\s*\;/i){
		$e{"mtype:$mcs"} = lc($1);
	    }else{
		$e{"mtype:$mcs"} = 'unknown';
	    }
	    $s .= $e{"mtype:$mcs"}.":";
	    if ( $e{"mhead:$mcs"} =~ /charset\=([^\;]+)\;/i){ 
		$e{"mchar:$mcs"} = lc($1);
	    }else{
		$e{"mchar:$mcs"} = 'unknown';
	    }
	    $s .= $e{"mchar:$mcs"}.":";
	    if ( $e{"mhead:$mcs"} =~ /Content-Transfer-Encoding\:\s*(\S+)/i){
		$e{"mcode:$mcs"} = lc($1);
	    }else{
		$e{"mcode:$mcs"} = 'unknown';
	    }
	    $s .= $e{"mcode:$mcs"}.":";
	    if ( $e{"mhead:$mcs"} =~ /name\=\"*([^\"\n]+)\"*/i){ #"
		$e{"mname:$mcs"} = $1;
	    }elsif( $e{"mhead:$mcs"} =~ /filename\=\"*([^\"\n]+)\"*/i){ #"
		$e{"mname:$mcs"} = $1;
	    }else{
		$e{"mname:$mcs"} = 'unknown';
	    }
	    $s .= $e{"mname:$mcs"};
	    print "$mcs = $s\n";
	    # print $e{"mbody:$mcs"};
	}
    }
    return 1;
}
